from _typeshed import Incomplete
from io import RawIOBase
from serial import SerialBase, SerialException

class SerialExceptionWithErrno(SerialException):
    errno: Incomplete
    def __init__(self, message, errno: Incomplete | None = ...) -> None: ...

class SocketSerial(SerialBase):
    BACKEND: str
    VIRTUAL_DEVICE: bool
    PYSERIAL_VERSION: Incomplete
    sock: Incomplete
    def open(self) -> None: ...
    def close(self) -> None: ...
    def in_waiting(self): ...
    def read(self, size: int = ...): ...
    def write(self, data) -> None: ...
    def flush(self) -> None: ...
    def reset_input_buffer(self) -> None: ...
    def reset_output_buffer(self) -> None: ...
    def send_break(self, duration: float = ...) -> None: ...
    def setDTR(self, on: int = ...) -> None: ...
    @property
    def cts(self): ...
    @property
    def dsr(self): ...
    @property
    def ri(self): ...
    @property
    def cd(self): ...
    def nonblocking(self) -> None: ...
    def dump(self, enable) -> None: ...

class Serial(SocketSerial, RawIOBase): ...
